/* key.c generated by valac 0.30.0, the Vala compiler
 * generated from key.vala, do not modify */

/* 
Copyright (c) 2011 by Simon Schneegans

This program is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the Free
Software Foundation, either version 3 of the License, or (at your option)
any later version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
more details.

You should have received a copy of the GNU General Public License along with
this program.  If not, see <http://www.gnu.org/licenses/>. 
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>


#define GNOME_PIE_TYPE_KEY (gnome_pie_key_get_type ())
#define GNOME_PIE_KEY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOME_PIE_TYPE_KEY, GnomePieKey))
#define GNOME_PIE_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOME_PIE_TYPE_KEY, GnomePieKeyClass))
#define GNOME_PIE_IS_KEY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOME_PIE_TYPE_KEY))
#define GNOME_PIE_IS_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOME_PIE_TYPE_KEY))
#define GNOME_PIE_KEY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOME_PIE_TYPE_KEY, GnomePieKeyClass))

typedef struct _GnomePieKey GnomePieKey;
typedef struct _GnomePieKeyClass GnomePieKeyClass;
typedef struct _GnomePieKeyPrivate GnomePieKeyPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GnomePieKey {
	GObject parent_instance;
	GnomePieKeyPrivate * priv;
};

struct _GnomePieKeyClass {
	GObjectClass parent_class;
};

struct _GnomePieKeyPrivate {
	gchar* _label;
	gchar* _accelerator;
	gint key_code;
	GdkModifierType modifiers;
};


static gpointer gnome_pie_key_parent_class = NULL;
static Display* gnome_pie_key_display;
static Display* gnome_pie_key_display = NULL;
static gint gnome_pie_key_shift_code;
static gint gnome_pie_key_shift_code = 0;
static gint gnome_pie_key_ctrl_code;
static gint gnome_pie_key_ctrl_code = 0;
static gint gnome_pie_key_alt_code;
static gint gnome_pie_key_alt_code = 0;
static gint gnome_pie_key_super_code;
static gint gnome_pie_key_super_code = 0;

GType gnome_pie_key_get_type (void) G_GNUC_CONST;
#define GNOME_PIE_KEY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GNOME_PIE_TYPE_KEY, GnomePieKeyPrivate))
enum  {
	GNOME_PIE_KEY_DUMMY_PROPERTY,
	GNOME_PIE_KEY_LABEL,
	GNOME_PIE_KEY_ACCELERATOR
};
GnomePieKey* gnome_pie_key_new (void);
GnomePieKey* gnome_pie_key_construct (GType object_type);
static void gnome_pie_key_set_accelerator (GnomePieKey* self, const gchar* value);
static void gnome_pie_key_set_label (GnomePieKey* self, const gchar* value);
GnomePieKey* gnome_pie_key_new_from_string (const gchar* stroke);
GnomePieKey* gnome_pie_key_construct_from_string (GType object_type, const gchar* stroke);
GnomePieKey* gnome_pie_key_new_from_values (guint keysym, GdkModifierType modifiers);
GnomePieKey* gnome_pie_key_construct_from_values (GType object_type, guint keysym, GdkModifierType modifiers);
void gnome_pie_key_press (GnomePieKey* self);
static GdkModifierType gnome_pie_key_get_modifiers (GnomePieKey* self);
static void gnome_pie_key_press_modifiers (GnomePieKey* self, GdkModifierType modifiers, gboolean down);
const gchar* gnome_pie_key_get_label (GnomePieKey* self);
const gchar* gnome_pie_key_get_accelerator (GnomePieKey* self);
static void gnome_pie_key_finalize (GObject* obj);
static void _vala_gnome_pie_key_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gnome_pie_key_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GnomePieKey* gnome_pie_key_construct (GType object_type) {
	GnomePieKey * self = NULL;
	const gchar* _tmp0_ = NULL;
	self = (GnomePieKey*) g_object_new (object_type, NULL);
	gnome_pie_key_set_accelerator (self, "");
	self->priv->modifiers = 0;
	self->priv->key_code = 0;
	_tmp0_ = _ ("Not bound");
	gnome_pie_key_set_label (self, _tmp0_);
	return self;
}


GnomePieKey* gnome_pie_key_new (void) {
	return gnome_pie_key_construct (GNOME_PIE_TYPE_KEY);
}


GnomePieKey* gnome_pie_key_construct_from_string (GType object_type, const gchar* stroke) {
	GnomePieKey * self = NULL;
	const gchar* _tmp0_ = NULL;
	guint keysym = 0U;
	const gchar* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	GdkModifierType _tmp3_ = 0;
	Display* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	GdkModifierType _tmp6_ = 0;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	g_return_val_if_fail (stroke != NULL, NULL);
	self = (GnomePieKey*) g_object_new (object_type, NULL);
	_tmp0_ = stroke;
	gnome_pie_key_set_accelerator (self, _tmp0_);
	_tmp1_ = stroke;
	gtk_accelerator_parse (_tmp1_, &_tmp2_, &_tmp3_);
	keysym = _tmp2_;
	self->priv->modifiers = _tmp3_;
	_tmp4_ = gnome_pie_key_display;
	_tmp5_ = XKeysymToKeycode (_tmp4_, keysym);
	self->priv->key_code = _tmp5_;
	_tmp6_ = self->priv->modifiers;
	_tmp7_ = gtk_accelerator_get_label (keysym, _tmp6_);
	_tmp8_ = _tmp7_;
	gnome_pie_key_set_label (self, _tmp8_);
	_g_free0 (_tmp8_);
	return self;
}


GnomePieKey* gnome_pie_key_new_from_string (const gchar* stroke) {
	return gnome_pie_key_construct_from_string (GNOME_PIE_TYPE_KEY, stroke);
}


GnomePieKey* gnome_pie_key_construct_from_values (GType object_type, guint keysym, GdkModifierType modifiers) {
	GnomePieKey * self = NULL;
	guint _tmp0_ = 0U;
	GdkModifierType _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	guint _tmp4_ = 0U;
	GdkModifierType _tmp5_ = 0;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	Display* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	gint _tmp10_ = 0;
	GdkModifierType _tmp11_ = 0;
	self = (GnomePieKey*) g_object_new (object_type, NULL);
	_tmp0_ = keysym;
	_tmp1_ = modifiers;
	_tmp2_ = gtk_accelerator_name (_tmp0_, _tmp1_);
	_tmp3_ = _tmp2_;
	gnome_pie_key_set_accelerator (self, _tmp3_);
	_g_free0 (_tmp3_);
	_tmp4_ = keysym;
	_tmp5_ = modifiers;
	_tmp6_ = gtk_accelerator_get_label (_tmp4_, _tmp5_);
	_tmp7_ = _tmp6_;
	gnome_pie_key_set_label (self, _tmp7_);
	_g_free0 (_tmp7_);
	_tmp8_ = gnome_pie_key_display;
	_tmp9_ = keysym;
	_tmp10_ = XKeysymToKeycode (_tmp8_, _tmp9_);
	self->priv->key_code = _tmp10_;
	_tmp11_ = modifiers;
	self->priv->modifiers = _tmp11_;
	return self;
}


GnomePieKey* gnome_pie_key_new_from_values (guint keysym, GdkModifierType modifiers) {
	return gnome_pie_key_construct_from_values (GNOME_PIE_TYPE_KEY, keysym, modifiers);
}


void gnome_pie_key_press (GnomePieKey* self) {
	GdkModifierType current_modifiers = 0;
	GdkModifierType _tmp0_ = 0;
	GdkModifierType _tmp1_ = 0;
	Display* _tmp2_ = NULL;
	Display* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	Display* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	GdkModifierType _tmp7_ = 0;
	Display* _tmp8_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gnome_pie_key_get_modifiers (self);
	current_modifiers = _tmp0_;
	gnome_pie_key_press_modifiers (self, current_modifiers, FALSE);
	_tmp1_ = self->priv->modifiers;
	gnome_pie_key_press_modifiers (self, _tmp1_, TRUE);
	_tmp2_ = gnome_pie_key_display;
	XFlush (_tmp2_);
	_tmp3_ = gnome_pie_key_display;
	_tmp4_ = self->priv->key_code;
	XTestFakeKeyEvent (_tmp3_, (guint) _tmp4_, TRUE, (gulong) 0);
	_tmp5_ = gnome_pie_key_display;
	_tmp6_ = self->priv->key_code;
	XTestFakeKeyEvent (_tmp5_, (guint) _tmp6_, FALSE, (gulong) 0);
	_tmp7_ = self->priv->modifiers;
	gnome_pie_key_press_modifiers (self, _tmp7_, FALSE);
	gnome_pie_key_press_modifiers (self, current_modifiers, TRUE);
	_tmp8_ = gnome_pie_key_display;
	XFlush (_tmp8_);
}


static GdkModifierType gnome_pie_key_get_modifiers (GnomePieKey* self) {
	GdkModifierType result = 0;
	GdkModifierType modifiers = 0;
	GdkModifierType _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	gtk_get_current_event_state (&_tmp0_);
	modifiers = _tmp0_;
	result = modifiers;
	return result;
}


static void gnome_pie_key_press_modifiers (GnomePieKey* self, GdkModifierType modifiers, gboolean down) {
	GdkModifierType _tmp0_ = 0;
	GdkModifierType _tmp4_ = 0;
	GdkModifierType _tmp8_ = 0;
	GdkModifierType _tmp12_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = modifiers;
	if ((_tmp0_ & GDK_CONTROL_MASK) > 0) {
		Display* _tmp1_ = NULL;
		gint _tmp2_ = 0;
		gboolean _tmp3_ = FALSE;
		_tmp1_ = gnome_pie_key_display;
		_tmp2_ = gnome_pie_key_ctrl_code;
		_tmp3_ = down;
		XTestFakeKeyEvent (_tmp1_, (guint) _tmp2_, _tmp3_, (gulong) 0);
	}
	_tmp4_ = modifiers;
	if ((_tmp4_ & GDK_SHIFT_MASK) > 0) {
		Display* _tmp5_ = NULL;
		gint _tmp6_ = 0;
		gboolean _tmp7_ = FALSE;
		_tmp5_ = gnome_pie_key_display;
		_tmp6_ = gnome_pie_key_shift_code;
		_tmp7_ = down;
		XTestFakeKeyEvent (_tmp5_, (guint) _tmp6_, _tmp7_, (gulong) 0);
	}
	_tmp8_ = modifiers;
	if ((_tmp8_ & GDK_MOD1_MASK) > 0) {
		Display* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		gboolean _tmp11_ = FALSE;
		_tmp9_ = gnome_pie_key_display;
		_tmp10_ = gnome_pie_key_alt_code;
		_tmp11_ = down;
		XTestFakeKeyEvent (_tmp9_, (guint) _tmp10_, _tmp11_, (gulong) 0);
	}
	_tmp12_ = modifiers;
	if ((_tmp12_ & GDK_SUPER_MASK) > 0) {
		Display* _tmp13_ = NULL;
		gint _tmp14_ = 0;
		gboolean _tmp15_ = FALSE;
		_tmp13_ = gnome_pie_key_display;
		_tmp14_ = gnome_pie_key_super_code;
		_tmp15_ = down;
		XTestFakeKeyEvent (_tmp13_, (guint) _tmp14_, _tmp15_, (gulong) 0);
	}
}


const gchar* gnome_pie_key_get_label (GnomePieKey* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_label;
	result = _tmp0_;
	return result;
}


static void gnome_pie_key_set_label (GnomePieKey* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_label);
	self->priv->_label = _tmp1_;
	g_object_notify ((GObject *) self, "label");
}


const gchar* gnome_pie_key_get_accelerator (GnomePieKey* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_accelerator;
	result = _tmp0_;
	return result;
}


static void gnome_pie_key_set_accelerator (GnomePieKey* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_accelerator);
	self->priv->_accelerator = _tmp1_;
	g_object_notify ((GObject *) self, "accelerator");
}


static void gnome_pie_key_class_init (GnomePieKeyClass * klass) {
	Display* _tmp0_ = NULL;
	Display* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	gint _tmp3_ = 0;
	Display* _tmp4_ = NULL;
	guint _tmp5_ = 0U;
	gint _tmp6_ = 0;
	Display* _tmp7_ = NULL;
	guint _tmp8_ = 0U;
	gint _tmp9_ = 0;
	Display* _tmp10_ = NULL;
	guint _tmp11_ = 0U;
	gint _tmp12_ = 0;
	gnome_pie_key_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GnomePieKeyPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_gnome_pie_key_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gnome_pie_key_set_property;
	G_OBJECT_CLASS (klass)->finalize = gnome_pie_key_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOME_PIE_KEY_LABEL, g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOME_PIE_KEY_ACCELERATOR, g_param_spec_string ("accelerator", "accelerator", "accelerator", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	_tmp0_ = XOpenDisplay (NULL);
	gnome_pie_key_display = _tmp0_;
	_tmp1_ = gnome_pie_key_display;
	_tmp2_ = gdk_keyval_from_name ("Shift_L");
	_tmp3_ = XKeysymToKeycode (_tmp1_, _tmp2_);
	gnome_pie_key_shift_code = _tmp3_;
	_tmp4_ = gnome_pie_key_display;
	_tmp5_ = gdk_keyval_from_name ("Control_L");
	_tmp6_ = XKeysymToKeycode (_tmp4_, _tmp5_);
	gnome_pie_key_ctrl_code = _tmp6_;
	_tmp7_ = gnome_pie_key_display;
	_tmp8_ = gdk_keyval_from_name ("Alt_L");
	_tmp9_ = XKeysymToKeycode (_tmp7_, _tmp8_);
	gnome_pie_key_alt_code = _tmp9_;
	_tmp10_ = gnome_pie_key_display;
	_tmp11_ = gdk_keyval_from_name ("Super_L");
	_tmp12_ = XKeysymToKeycode (_tmp10_, _tmp11_);
	gnome_pie_key_super_code = _tmp12_;
}


static void gnome_pie_key_instance_init (GnomePieKey * self) {
	self->priv = GNOME_PIE_KEY_GET_PRIVATE (self);
}


static void gnome_pie_key_finalize (GObject* obj) {
	GnomePieKey * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNOME_PIE_TYPE_KEY, GnomePieKey);
	_g_free0 (self->priv->_label);
	_g_free0 (self->priv->_accelerator);
	G_OBJECT_CLASS (gnome_pie_key_parent_class)->finalize (obj);
}


GType gnome_pie_key_get_type (void) {
	static volatile gsize gnome_pie_key_type_id__volatile = 0;
	if (g_once_init_enter (&gnome_pie_key_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GnomePieKeyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnome_pie_key_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomePieKey), 0, (GInstanceInitFunc) gnome_pie_key_instance_init, NULL };
		GType gnome_pie_key_type_id;
		gnome_pie_key_type_id = g_type_register_static (G_TYPE_OBJECT, "GnomePieKey", &g_define_type_info, 0);
		g_once_init_leave (&gnome_pie_key_type_id__volatile, gnome_pie_key_type_id);
	}
	return gnome_pie_key_type_id__volatile;
}


static void _vala_gnome_pie_key_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GnomePieKey * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNOME_PIE_TYPE_KEY, GnomePieKey);
	switch (property_id) {
		case GNOME_PIE_KEY_LABEL:
		g_value_set_string (value, gnome_pie_key_get_label (self));
		break;
		case GNOME_PIE_KEY_ACCELERATOR:
		g_value_set_string (value, gnome_pie_key_get_accelerator (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gnome_pie_key_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GnomePieKey * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNOME_PIE_TYPE_KEY, GnomePieKey);
	switch (property_id) {
		case GNOME_PIE_KEY_LABEL:
		gnome_pie_key_set_label (self, g_value_get_string (value));
		break;
		case GNOME_PIE_KEY_ACCELERATOR:
		gnome_pie_key_set_accelerator (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



